## metview 5.9.1

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.6.0 FATAL_ERROR )

include( ${INCLUDE_CONFIG}-local-config.cmake OPTIONAL )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake;${CMAKE_MODULE_PATH}" )

include( ecbuild_bundle )

project( MetviewMiniBundle VERSION 5.9.1 LANGUAGES C CXX )
set(CPACK_PACKAGE_NAME Metview)  # so that the source tarball will have the name 'Metview'


# list all the packages we incorporate into the bundle
set(MV_BUNDLE_PACKAGES METVIEW MARS_CLIENT MIR ATLAS ECKIT)

if(METVIEW_SITE STREQUAL ecmwf )
    list(APPEND MV_BUNDLE_PACKAGES FDB)
    list(APPEND MV_BUNDLE_PACKAGES ECMF_CONFIGS)
endif()

# create a variabe for each package we bundle
foreach (bunpack ${MV_BUNDLE_PACKAGES})
    set(MV_BUNDLE_CONTAINS_${bunpack} 1)
endforeach()


# -------------------------------------------------------------------------------------
# settings which are required across the packages to get a working Metview installation

#general
set(ENABLE_ODB           OFF CACHE BOOL "ODB support")
set(ENABLE_EXPERIMENTAL  OFF CACHE BOOL "Experimental features")
set(ENABLE_FORTRAN       NOT_SET CACHE BOOL "Fortran features")

#mars
set(ECMWF             OFF CACHE BOOL "build the client as for ECMWF")
set(CONFIG_FDB        OFF CACHE BOOL "database configuration to access FDB")
set(ENABLE_UDP_STATS  OFF CACHE BOOL  "")


# if the user did bot supply a value for ENABLE_FORTRAN, then unset it
# (we want to then use the default behaviour, per package)
if(ENABLE_FORTRAN STREQUAL "NOT_SET")
    unset(ENABLE_FORTRAN)
    unset(ENABLE_FORTRAN CACHE)
endif()

# -------------------------------------------------------------------------------------

macro(my_bundle_pkg)
    ecbuild_bundle( ${ARGV} )
endmacro()

ecbuild_bundle_initialize()

    ecbuild_add_option( FEATURE EXPOSE_SUBPACKAGES
                        DEFAULT OFF
                        DESCRIPTION "Allow separate use of the sub-packages in the bundle")



    # if the installer does not want to expose the sub-packages then we need to:
    # a) change $PREFIX so that everything is installed into a sub-directory
    # b) change the location of the Metview startup script so it's installed
    #    where intended (Metview takes care of this)

    if (NOT ENABLE_EXPOSE_SUBPACKAGES)
        set(ORIGINAL_CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
        set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/lib/metview-bundle")
    endif()

    if(MV_BUNDLE_CONTAINS_ECMWF_CONFIGS )
        ecbuild_bundle( PROJECT metview-ecmwf-configs  STASH "metv/metview-ecmwf-configs"  TAG  master  UPDATE )
    endif()


    if(MV_BUNDLE_CONTAINS_FDB)
        set( FDB_CONF_FILE /usr/local/apps/fdb/etc/Config )
        list(APPEND MV_BUNDLE_PACKAGES FDB)
        ecbuild_bundle( PROJECT fdb                STASH "mars/fdb_vintage"            TAG     4.10.0   UPDATE )
    else()
        set(FDB_DIR "/dummy/path/for/bundle")
    endif()

    my_bundle_pkg( PROJECT eckit        STASH "ecsdk/eckit"       TAG  1.12.0 )
    my_bundle_pkg( PROJECT atlas        STASH "atlas/atlas"       TAG  0.21.0 )
    my_bundle_pkg( PROJECT mir          STASH "mir/mir"           TAG  1.5.2 )
    my_bundle_pkg( PROJECT mars-client  STASH "mars/mars-client"  TAG  6.28.5 )
    my_bundle_pkg( PROJECT metview      STASH "metv/metview"      TAG  5.9.1 )

    ecbuild_dont_pack(FILES configure.sh;ecmwf;make-tarball.sh;test-tarball.sh;configure.clang.sh;bamboo)

ecbuild_bundle_finalize()


ecbuild_info("ENABLE_EXPOSE_SUBPACKAGES is ${ENABLE_EXPOSE_SUBPACKAGES}:")
if (ENABLE_EXPOSE_SUBPACKAGES)
    ecbuild_info("All packages in the bundle will be installed at the same level into:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
else()
    ecbuild_info("All packages in the bundle will be installed into a sub-directory:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
    ecbuild_info ("The Metview startup script will be installed into:")
    ecbuild_info("  ${ORIGINAL_CMAKE_INSTALL_PREFIX}/bin")
endif()

=== eckit/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.6 FATAL_ERROR )

project( eckit CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 3.0 )

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

### architecture checks

include(cmake/check_time_t_Y2038.cmake) # check Y2038 time_t compatibility

### dependencies and options

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

ecbuild_add_option( FEATURE SANDBOX
                    DEFAULT OFF
                    DESCRIPTION "Sandbox playground for prototyping code that may never see the light of day" )

### thread library ( preferably pthreads ) --- Must be called before FindCUDA!

if( ${CMAKE_VERSION} VERSION_LESS 3.14 )
    # Following variable is unused for CMake > 3.14
    set( CMAKE_THREAD_PREFER_PTHREAD 1 )
endif()

if( NOT DEFINED THREADS_PREFER_PTHREAD_FLAG )
  set( THREADS_PREFER_PTHREAD_FLAG 1 )
endif()
### Set THREADS_HAVE_PTHREAD_ARG variable to false so that it can be recomputed based on
### THREADS_PREFER_PTHREAD_FLAG, in case other project had it on a different setting.
### This is certainly a CMake bug ( see ECKIT-426 )
set( THREADS_HAVE_PTHREAD_ARG FALSE )
find_package( Threads REQUIRED )
set( THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} )

### eckit::mpi

ecbuild_add_option( FEATURE MPI
                    DEFAULT ON
                    DESCRIPTION "Use system MPI libraries"
                    REQUIRED_PACKAGES "MPI COMPONENTS C" )

### eckit::cmd

ecbuild_add_option( FEATURE ECKIT_CMD
                    DEFAULT ON
                    DESCRIPTION "Utilities for administration tools"
                    REQUIRED_PACKAGES "LEXYACC" "Curses" )

### eckit::sql

ecbuild_add_option( FEATURE ECKIT_SQL
                    DEFAULT ON
                    DESCRIPTION "An SQL engine"
                    REQUIRED_PACKAGES "LEXYACC" )

### Eigen

ecbuild_add_option( FEATURE EIGEN
                    DESCRIPTION "Eigen linear algebra library"
                    REQUIRED_PACKAGES Eigen3 )

set_package_properties( Eigen3 PROPERTIES
                        DESCRIPTION "C++ template library for linear algebra"
                      )

### RADOS

ecbuild_add_option( FEATURE RADOS
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados storage support"
                    REQUIRED_PACKAGES Rados )

### Armadillo

ecbuild_add_option( FEATURE ARMADILLO
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "Armadillo linear algebra library"
                    REQUIRED_PACKAGES Armadillo )

set_package_properties( Armadillo PROPERTIES
                        DESCRIPTION "C++ linear algebra"
                      )

### MKL

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "MKL linear algebra library"
                    REQUIRED_PACKAGES MKL )

### Compression

ecbuild_add_option( FEATURE BZIP2
                    DESCRIPTION "BZip2 support for compression"
                    REQUIRED_PACKAGES BZip2 )

ecbuild_add_option( FEATURE SNAPPY
                    DESCRIPTION "Snappy support for compression"
                    REQUIRED_PACKAGES Snappy )

ecbuild_add_option( FEATURE LZ4
                    DESCRIPTION "LZ4 support for compression"
                    REQUIRED_PACKAGES LZ4 )

ecbuild_add_option( FEATURE AEC
                    DESCRIPTION "AEC support for compression"
                    REQUIRED_PACKAGES AEC )

### LAPACK

if( ECKIT_HAVE_MKL )
    set( ECKIT_HAVE_LAPACK 1 )
    set( LAPACK_LIBRARIES ${MKL_LIBRARIES} )
else()
    ecbuild_add_option( FEATURE LAPACK
                        DESCRIPTION "Linear Algebra PACKage"
                        REQUIRED_PACKAGES "LAPACK QUIET" )
endif()

### OpenSSL (for SHA1)

ecbuild_add_option( FEATURE SSL
                    DESCRIPTION "OpenSSL support"
                    REQUIRED_PACKAGES OpenSSL )

if( OPENSSL_FOUND )
  ecbuild_info("OpenSSL version ${OPENSSL_VERSION} -- libs [${OPENSSL_LIBRARIES}] incs [${OPENSSL_INCLUDE_DIR}]")
endif()

### xxHash

ecbuild_add_option( FEATURE XXHASH
                    DESCRIPTION "Use xxHash for non-crypto hashing in data integrity checks"
                    REQUIRED_PACKAGES "xxHash QUIET" )

if( XXHASH_FOUND )
  ecbuild_info("xxHash -- libs [${XXHASH_LIBRARIES}] incs [${XXHASH_INCLUDE_DIRS}]")
endif()

#### Curl

ecbuild_add_option( FEATURE CURL
                    DESCRIPTION "Curl library for transfering data with URLs"
                    REQUIRED_PACKAGES CURL )

#### Jemalloc

ecbuild_add_option( FEATURE JEMALLOC
                    DEFAULT OFF
                    DESCRIPTION "Link against jemalloc memory allocator"
                    REQUIRED_PACKAGES Jemalloc )

#### CUDA

ecbuild_add_option( FEATURE CUDA
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "CUDA GPU linear algebra operations"
                    REQUIRED_PACKAGES CUDA )

### ViennaCL

ecbuild_add_option( FEATURE VIENNACL
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "ViennaCL OpenCL linear algebra operations"
                    REQUIRED_PACKAGES ViennaCL )

set_package_properties( ViennaCL PROPERTIES
                        DESCRIPTION "linear algebra library for computations on many-core architectures"
                        TYPE RECOMMENDED
                        PURPOSE "Dense and sparse matrix operations on OpenCL devices" )

### LibRsync

ecbuild_add_option( FEATURE RSYNC
                    DEFAULT OFF
                    DESCRIPTION "librsync implementation of the rsync algorithm"
                    REQUIRED_PACKAGES LibRsync )
if( HAVE_RSYNC )
  set( LIBRSYNC_LIBRARIES rsync )
endif()

### Performance tests

ecbuild_add_option( FEATURE EXTRA_TESTS
                    DEFAULT OFF
                    DESCRIPTION "Add additional unit/performance tests" )

### async io support

find_package( AIO )
ecbuild_add_option( FEATURE AIO
                    DEFAULT ON
                    CONDITION ${AIO_FOUND}
                    DESCRIPTION "support for asynchronous IO")

### c math library, needed when including "math.h"

find_package( CMath )

### realtime library implements shm_open on Linux
if( CMAKE_SYSTEM_NAME MATCHES "Linux" )
    find_package( Realtime )
    if( REALTIME_FOUND ) # check that aio needs realtime
        set( RT_LIBRARIES ${RT_LIB} )
    endif()
else()
  set( RT_LIBRARIES "" )
endif()

###############################################################################
# checks

# check thread library is pthreads
if( NOT ${CMAKE_USE_PTHREADS_INIT} )
    message( FATAL_ERROR "Only pthreads supported - thread library found is [${THREADS_LIBRARIES}]" )
endif()

############################################################################################
# export package info

set( ECKIT_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( ECKIT_LIBRARIES      eckit eckit_geometry eckit_linalg eckit_maths eckit_mpi eckit_web )

if( HAVE_ECKIT_CMD)
  list( APPEND ECKIT_LIBRARIES eckit_cmd )
endif()

if( HAVE_EXPERIMENTAL )

  list( APPEND ECKIT_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/experimental )

endif()

get_directory_property( ECKIT_DEFINITIONS COMPILE_DEFINITIONS )

############################################################################################
# sources

ecbuild_find_project_files()

include_directories( ${ECKIT_INCLUDE_DIRS} )
if( HAVE_EIGEN )
    include_directories( ${EIGEN3_INCLUDE_DIR} )
endif()

add_subdirectory( bamboo )
add_subdirectory( doc )
add_subdirectory( src )
add_subdirectory( tests )
add_subdirectory( regressions )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files SOURCES
                       TODO AUTHORS README.md NOTICE LICENSE INSTALL ChangeLog COPYING )

############################################################################################
# finalize

foreach( _lib ${ECKIT_LIBRARIES} )
  if( TARGET ${_lib} )
    ecbuild_pkgconfig( NAME ${_lib}
                       DESCRIPTION "ECMWF C++ Toolkit - ${_lib} library"
                       URL "https://software.ecmwf.int/wiki/display/ECKIT/ecKit"
                       LIBRARIES ${_lib} )
  endif()
endforeach()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== mir/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.6 FATAL_ERROR )
find_package(ecbuild 3.0 REQUIRED)

project(mir VERSION 1.5.2 LANGUAGES C CXX)

include( ecbuild_system NO_POLICY_SCOPE )

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

###############################################################################
# project

ecbuild_add_option( FEATURE MIR_TOOLS          DEFAULT OFF DESCRIPTION "install mir tools" )
ecbuild_add_option( FEATURE MIR_DOWNLOAD_MASKS DEFAULT ON  DESCRIPTION "download LSM files" )

ecbuild_add_option( FEATURE TEST_ASSERTIONS    DEFAULT ON  DESCRIPTION "test: regressions" )
ecbuild_add_option( FEATURE OMP                DEFAULT ON  DESCRIPTION "support for OpenMP shared memory parallelism" )
ecbuild_add_option( FEATURE MPI                DEFAULT OFF DESCRIPTION "support for MPI distributed parallelism" )
ecbuild_add_option( FEATURE NETCDF             DEFAULT ON  DESCRIPTION "support for NetCDF4" REQUIRED_PACKAGES NetCDF4 )
ecbuild_add_option( FEATURE PNG                DEFAULT OFF DESCRIPTION "support for PNG encoding" REQUIRED_PACKAGES PNG )

ecbuild_use_package( PROJECT eccodes VERSION 2.16 REQUIRED )
ecbuild_use_package( PROJECT eckit   VERSION 1.8  REQUIRED )
ecbuild_use_package( PROJECT atlas   VERSION 0.19 REQUIRED )

if(ATLAS_FOUND)
    set(HAVE_ATLAS 1)
endif()

if(HAVE_PNG)
    add_definitions(${PNG_DEFINITIONS})
endif()


# OMP/MPI features handling
if( ENABLE_OMP )
  ecbuild_enable_omp()
else()
  ecbuild_enable_ompstubs()
endif()

if( ENABLE_MPI )
  ecbuild_enable_mpi()
  if( NOT MPI_CXX_FOUND )
    set( HAVE_MPI 0 )
  endif()
endif()


###############################################################################
# contents

### export package to other ecbuild packages

set( MIR_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( MIR_LIBRARIES      mir )

get_directory_property( COMPILE_DEFINITIONS MIR_DEFINITIONS )

foreach( _tpl ${MIR_TPLS} )
  string( TOUPPER ${_tpl} TPL )
  if( ${TPL}_FOUND )
    list( APPEND MIR_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS} ${${TPL}_TPL_DEFINITIONS})
    list( APPEND MIR_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} ${${TPL}_TPL_INCLUDE_DIRS} )
    list( APPEND MIR_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} ${${TPL}_TPL_LIBRARIES})
  endif()
endforeach()

### include directories

include_directories( ${MIR_INCLUDE_DIRS} ${MIR_EXTRA_INCLUDE_DIRS}  )

add_subdirectory( "src" )
add_subdirectory( "etc" )
add_subdirectory( "share" )
add_subdirectory( "tests" )

### installation

# install( DIRECTORY share DESTINATION ${CMAKE_INSTALL_PREFIX} )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files SOURCES
                       TODO AUTHORS README NOTICE LICENSE INSTALL ChangeLog COPYING
                       DONT_PACK
                       BUGS )

############################################################################################
# packaging and installation

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== atlas/src/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

if( atlas_HAVE_OMP_CXX )
  set( atlas_HAVE_OMP_CXX 1 )
else()
  set( atlas_HAVE_OMP_CXX 0 )
endif()

if( atlas_HAVE_OMP_Fortran )
  set( atlas_HAVE_OMP_Fortran 1 )
else()
  set( atlas_HAVE_OMP_Fortran 0 )
endif()

if( atlas_HAVE_TESSELATION )
  set( atlas_HAVE_TESSELATION 1 )
else()
  set( atlas_HAVE_TESSELATION 0 )
endif()

if( atlas_HAVE_FORTRAN )
  set( atlas_HAVE_FORTRAN 1 )
else()
  set( atlas_HAVE_FORTRAN 0 )
endif()

if( atlas_HAVE_TRANS )
  set( atlas_HAVE_TRANS 1 )
else()
  set( atlas_HAVE_TRANS 0 )
endif()

if( atlas_HAVE_FFTW )
  set( atlas_HAVE_FFTW 1 )
else()
  set( atlas_HAVE_FFTW 0 )
endif()

if( atlas_HAVE_BOUNDSCHECKING )
  set( atlas_HAVE_BOUNDSCHECKING 1 )
else()
  set( atlas_HAVE_BOUNDSCHECKING 0 )
endif()

if( atlas_HAVE_INIT_SNAN )
  set( atlas_HAVE_INIT_SNAN 1 )
else()
  set( atlas_HAVE_INIT_SNAN 0 )
endif()

if( atlas_HAVE_GRIDTOOLS_STORAGE )
  set( atlas_HAVE_GRIDTOOLS_STORAGE 1 )
else()
  set( atlas_HAVE_GRIDTOOLS_STORAGE 0 )
endif()

add_subdirectory( atlas_acc_support )

add_subdirectory( atlas )

if( atlas_HAVE_FORTRAN )
 add_subdirectory( atlas_f )
endif()

add_subdirectory( apps )
add_subdirectory( tests )

if( HAVE_SANDBOX )
    add_subdirectory( sandbox )
endif()

=== metview/src/CMakeLists.txt ===

#add_subdirectory( libMars )
add_subdirectory( libMvMacroApi )
add_subdirectory( libMetview )
add_subdirectory( libFTimeUtil )

#add_subdirectory( Datacoverage )
add_subdirectory( Divrot )
add_subdirectory( Eccharts )
add_subdirectory( Ecfile )
add_subdirectory( Event )
add_subdirectory( Macro )
add_subdirectory( MvApp )
add_subdirectory( Flextra )
add_subdirectory( GribVectors )
add_subdirectory( Hovmoeller )
add_subdirectory( KML )
add_subdirectory( Met3D )
add_subdirectory( ObsFilter )
add_subdirectory( Percentile )
add_subdirectory( PottF )
add_subdirectory( Spectra )
add_subdirectory( PythonServe )
add_subdirectory( Relhum )
add_subdirectory( Rttov )
add_subdirectory( Scm )
add_subdirectory( Stations )
add_subdirectory( StdAppManager )
add_subdirectory( Thermo )
add_subdirectory( Velstr )
add_subdirectory( Vapor )
add_subdirectory( XSection )

if(ENABLE_INPE)
    add_subdirectory(CptecAccess)
endif()

if(ENABLE_URL_DOWNLOAD)
    add_subdirectory(Download)
endif()

if(ENABLE_UI)
    add_subdirectory(libMvQtUtil)
    add_subdirectory(libMvQtGui)
    #add_subdirectory(libMvQtTextPager)
    add_subdirectory(AppMod)
    add_subdirectory(BufrExaminer)
    add_subdirectory(DebugTools)
    add_subdirectory(ExamineManager)
    add_subdirectory(FlextraExaminer)
    add_subdirectory(GeopExaminer)
    add_subdirectory(GribExaminer)
    add_subdirectory(MacroEditor)
    add_subdirectory(NcExaminer)
    add_subdirectory(OgcClient)
    add_subdirectory(ScmEditor)
 
    # omitted: VisTools


    if(ENABLE_EXPERIMENTAL)
        add_subdirectory(MarsCatalog)
    endif()

    add_subdirectory(Desktop)
endif()


if(ENABLE_PLOTTING)
    add_subdirectory(uPlot)
    add_subdirectory(MagML)
    add_subdirectory(Reprojection)

    if(AT_ECMWF)
        add_subdirectory(Meteogram)
    endif()
endif()


if(ENABLE_ODB)
    add_subdirectory(Odb)
    if(ENABLE_UI)
        add_subdirectory(OdbExaminer)
    endif()
endif()


# still to do:
#     ensure that contents of images directory are put into tarball

# will not do:  libMars-ecregrid Obstat ObstatCurveTool ObstatScatterTool

# propagate ModuleObjectSpecFiles to the parent scope so we can use it again
set(ModuleObjectSpecFiles ${ModuleObjectSpecFiles} PARENT_SCOPE)
set(ModuleXpmFiles        ${ModuleXpmFiles}        PARENT_SCOPE)
set(ModuleSvgFiles        ${ModuleSvgFiles}        PARENT_SCOPE)

=== mir/tests/CMakeLists.txt ===

# Setup cache directory
set( TEST_ECKIT_CACHE_DIR  ${CMAKE_CURRENT_BINARY_DIR}/cache/ )
file( REMOVE_RECURSE ${TEST_ECKIT_CACHE_DIR} )


# Set list of input data files
set(TEST_INPUT_FILES
    "2t_O640.grib"
    "msl_N640.grib"
    "msl_regular_ll_1-1.grib"
    "msl_regular_ll_2-2.grib"
    "msl_regular_ll_3-3.grib"
    "q_F640.grib"
    "vo-d_sh.grib"
    "z_sh.grib")

if(HAVE_NETCDF AND ATLAS_HAVE_TESSELATION)
   list(APPEND TEST_INPUT_FILES "nemo.nc")
endif()

# Set interpolation tests
# (each line is an interpolation, the previous-to-last entry in each line is a file to download)
unset(_test_reqs)
foreach( _in ${TEST_INPUT_FILES})
  foreach( _pproc
          ""
          "--grid=1/1 --area=40/20/20/40"
          "--grid=1/1 --area=40/20/20/40 --frame=2"
          "--grid=2/2"
          "--grid=3/3"
          "--rotation=-90/0"
          "--rotation=-89/1" )
      if( "${_pproc}" STREQUAL "" )
        set(_label "mir_tests_nointerpol ${_in}")
      else()
        set(_label "mir_tests_interpol ${_in} to ${_pproc}")
      endif()
      string(REGEX REPLACE "[.]grib"      ""  _label ${_label})
      string(REGEX REPLACE "[^A-Za-z0-9]" "_" _label ${_label})
      string(REGEX REPLACE "[ _]+"        "_" _label ${_label})
      if( NOT (_in MATCHES ".*_sh[.]grib$" AND _pproc MATCHES "--frame=.*" OR
               _in MATCHES ".*[.]nc$" AND _pproc MATCHES "^$" ))

        if( _in MATCHES ".*[.]nc$" )
          set(_pproc "${_pproc} --interpolation=linear")
        endif()

        set(_out "${_label}.grib")
        list(APPEND _test_reqs "${_pproc} ${_in} ${_out}")

      endif()
  endforeach()
endforeach()

unset(_tests_src_files)
foreach(_t ${_test_reqs})
  separate_arguments(_t)
  list(GET    _t -2 _file)
  list(APPEND _tests_src_files ${_file})
endforeach()
list(REMOVE_DUPLICATES _tests_src_files)

ecbuild_get_test_multidata(
    TARGET download_mir_tests_files
    NAMES  ${_tests_src_files} )


# Set testing environment
if( NOT eccodes_BASE_DIR )
    if( TARGET "grib_compare" )
        get_target_property( CMD_GRIB_COMPARE "grib_compare" LOCATION )
    endif()
    if( NOT CMD_GRIB_COMPARE )
        find_program( CMD_GRIB_COMPARE "grib_compare" )
    endif()
    if( CMD_GRIB_COMPARE )
        get_filename_component( _grib_compare_dir "${CMD_GRIB_COMPARE}" PATH )
        get_filename_component( eccodes_BASE_DIR "${_grib_compare_dir}" ABSOLUTE )
        set( eccodes_BASE_DIR "${eccodes_BASE_DIR}/../" )
    else()
        ecbuild_critical("Could not guess eccodes_BASE_DIR, nor find grib_compare (in bundle nor in path) as an alternative" )
    endif()
endif()

set( _testEnvironment
    "MIR_DEBUG=1"
    "MIR_HOME=${CMAKE_BINARY_DIR}"
    "TEST_ECKIT_CACHE_DIR=${TEST_ECKIT_CACHE_DIR}")
if( eccodes_HAVE_INSTALL_ECCODES_DEFINITIONS )
    list( APPEND _testEnvironment "ECCODES_DEFINITION_PATH=${eccodes_BASE_DIR}/share/eccodes/definitions" )
endif()
if( eccodes_HAVE_INSTALL_ECCODES_SAMPLES )
    list( APPEND _testEnvironment "ECCODES_SAMPLES_PATH=${eccodes_BASE_DIR}/share/eccodes/samples" )
endif()

# Unit tests: simple interpolations
foreach(_t ${_test_reqs})
  separate_arguments(_t)
  list(GET _t -1 _out)
  string(REGEX REPLACE "[.]grib$" "" _label ${_out})

  ecbuild_add_test(
      TARGET       ${_label}
      COMMAND      $<TARGET_FILE:mir-tool>
      ARGS         "--caching=0" ${_t}
      TEST_DEPENDS download_mir_tests_files
      ENVIRONMENT  ${_testEnvironment} )

endforeach()


add_subdirectory(assertions)
add_subdirectory(plans)
add_subdirectory(unit)

=== atlas/src/atlas_acc_support/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

if( atlas_HAVE_ACC )

  if( NOT (CMAKE_C_COMPILER_ID MATCHES ${CMAKE_Fortran_COMPILER_ID}) )
    add_custom_command(
        OUTPUT  ${CMAKE_BINARY_DIR}/lib/libatlas_acc_support.so ${CMAKE_CURRENT_BINARY_DIR}/atlas_acc_map_data.c.o
        COMMAND ${ACC_C_COMPILER} ${ACC_C_FLAGS} ${ACC_C_INCLUDE} -fPIC -o ${CMAKE_CURRENT_BINARY_DIR}/atlas_acc_map_data.c.o
                -c ${CMAKE_CURRENT_SOURCE_DIR}/atlas_acc_map_data.c
        COMMAND mkdir -p ${CMAKE_BINARY_DIR}/lib
        COMMAND ${ACC_C_COMPILER} ${ACC_C_FLAGS} -shared -o ${CMAKE_BINARY_DIR}/lib/libatlas_acc_support.so
                ${CMAKE_CURRENT_BINARY_DIR}/atlas_acc_map_data.c.o
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/atlas_acc_map_data.c
        COMMENT "Building atlas_acc_support with ${ACC_C_COMPILER}"
    )
    add_custom_target( build-atlas_acc_support ALL DEPENDS ${CMAKE_BINARY_DIR}/lib/libatlas_acc_support.so )
    add_library( atlas_acc_support SHARED IMPORTED GLOBAL )
    set_property( TARGET atlas_acc_support PROPERTY IMPORTED_LOCATION ${CMAKE_BINARY_DIR}/lib/libatlas_acc_support.so )
    set_property( TARGET atlas_acc_support PROPERTY IMPORTED_NO_SONAME TRUE )
    set_property( TARGET atlas_acc_support PROPERTY IMPORTED_INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR} )
    add_dependencies( atlas_acc_support build-atlas_acc_support )
    install( FILES ${CMAKE_BINARY_DIR}/lib/libatlas_acc_support.so DESTINATION lib/ )

  else()

    ecbuild_add_library( TARGET atlas_acc_support SOURCES atlas_acc_map_data.c )
    target_compile_options( atlas_acc_support PRIVATE ${ACC_C_FLAGS} )
    target_link_libraries( atlas_acc_support PRIVATE ${ACC_C_FLAGS} )

  endif()

endif()

=== atlas/src/atlas_f/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/../atlas/atlas_f.h @ONLY )

execute_process( COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.fypp ${CMAKE_CURRENT_BINARY_DIR}/../atlas/atlas_f.fypp)

install( FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.fypp
  ${CMAKE_CURRENT_BINARY_DIR}/../atlas/atlas_f.h
  DESTINATION
  ${INSTALL_INCLUDE_DIR}/atlas )


### fortran bindings

function(generate_fortran_bindings output filename)

  set( options "" )
  set( single_value_args OUTPUT MODULE )
  set( multi_value_args "" )
  cmake_parse_arguments( _PAR "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )

  get_filename_component(base ${filename} NAME_WE)
  set(base_abs ${CMAKE_CURRENT_SOURCE_DIR}/${base})
  set(outfile ${CMAKE_CURRENT_BINARY_DIR}/${base}_c_binding.f90)

  if( _PAR_OUTPUT )
    set(outfile ${_PAR_OUTPUT})
  endif()
  set(${output} ${${output}} ${outfile} PARENT_SCOPE)

  if( NOT _PAR_MODULE )
    set( _PAR_MODULE "atlas_${base}_c_binding" )
  endif()

  set( FINT32 "integer(c_int)"  )
  set( FINT64 "integer(c_long)" )
  set( F_GIDX ${FINT${ATLAS_BITS_GLOBAL}} )
  set( F_IDX ${FINT${ATLAS_BITS_LOCAL}} )

  add_custom_command(
    OUTPUT ${outfile}
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/tools/c2f.py ${CMAKE_CURRENT_SOURCE_DIR}/${filename}
            -o ${outfile} -m ${_PAR_MODULE}
            -t '{"idx_t":"${F_IDX}","gidx_t":"${F_GIDX}"}'
    DEPENDS ${filename} )
  set_source_files_properties(${outfile} PROPERTIES GENERATED TRUE)
endfunction()

generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/Grid.h
    MODULE    atlas_grid_Grid_c_binding
    OUTPUT    grid_Grid_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/Structured.h
    MODULE    atlas_grid_Structured_c_binding
    OUTPUT    grid_Structured_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/Unstructured.h
    MODULE    atlas_grid_Unstructured_c_binding
    OUTPUT    grid_Unstructured_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/distribution/DistributionImpl.h
    MODULE atlas_distribution_c_binding
    OUTPUT distribution_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/vertical/VerticalInterface.h
    MODULE atlas_vertical_c_binding
    OUTPUT vertical_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/Partitioner.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/projection/detail/ProjectionImpl.h
    MODULE atlas_projection_c_binding
    OUTPUT projection_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/detail/MeshIntf.h
    MODULE    atlas_mesh_c_binding
    OUTPUT    atlas_mesh_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/Nodes.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/Connectivity.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/HybridElements.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/Elements.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/ElementType.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildParallelFields.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildPeriodicBoundaries.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildHalo.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildEdges.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildDualMesh.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/WriteLoadBalanceReport.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/meshgenerator/detail/MeshGeneratorInterface.h
    MODULE atlas_meshgenerator_c_binding
    OUTPUT meshgenerator_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/output/Output.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/output/detail/GmshInterface.h
  MODULE    atlas_output_gmsh_c_binding
  OUTPUT    output_Gmsh_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/field/State.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/field/detail/FieldInterface.h
    MODULE    atlas_field_c_binding
    OUTPUT    field_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/field/FieldSet.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/FunctionSpaceInterface.h
    MODULE atlas_functionspace_c_binding
    OUTPUT functionspace_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/SpectralInterface.h
    MODULE    atlas_functionspace_Spectral_c_binding
    OUTPUT    functionspace_Spectral_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/StructuredColumnsInterface.h
    MODULE    atlas_functionspace_StructuredColumns_c_binding
    OUTPUT    functionspace_StructuredColumns_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/NodeColumnsInterface.h
    MODULE    atlas_functionspace_NodeColumns_c_binding
    OUTPUT    functionspace_NodeColumns_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/EdgeColumns.h
    MODULE    atlas_functionspace_EdgeColumns_c_binding
    OUTPUT    functionspace_EdgeColumns_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/PointCloudInterface.h
    MODULE    atlas_functionspace_PointCloud_c_binding
    OUTPUT    functionspace_PointCloud_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/Nabla.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/Nabla.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/Method.h )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/fvm/Method.h
    MODULE    atlas_fvm_method_c_binding
    OUTPUT    fvm_method_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/interpolation/Interpolation.h
    MODULE    atlas_interpolation_c_binding
    OUTPUT    interpolation_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/trans/detail/TransInterface.h
    MODULE    atlas_trans_c_binding
    OUTPUT    trans_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Allocate.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Metadata.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Config.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Geometry.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/KDTree.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/output/detail/GmshIO.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/parallel/HaloExchange.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/parallel/GatherScatter.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/parallel/Checksum.h)
generate_fortran_bindings(FORTRAN_BINDINGS internals/atlas_read_file.h)
generate_fortran_bindings(FORTRAN_BINDINGS internals/Library.h)
generate_fortran_bindings(FORTRAN_BINDINGS runtime/atlas_trace.h MODULE atlas_trace_c_binding OUTPUT atlas_trace_c_binding.f90 )


### atlas fortran lib
ecbuild_add_library( TARGET atlas_f
    AUTO_VERSION
    SOURCES
        ${FORTRAN_BINDINGS}
        atlas_module.F90
        util/atlas_kinds_module.F90
        util/atlas_JSON_module.F90
        util/atlas_Config_module.F90
        util/atlas_Geometry_module.F90
        util/atlas_KDTree_module.F90
        util/atlas_Metadata_module.F90
        util/atlas_allocate_module.F90
        output/atlas_output_module.F90
        functionspace/atlas_FunctionSpace_module.F90
        functionspace/atlas_functionspace_EdgeColumns_module.F90
        functionspace/atlas_functionspace_NodeColumns_module.fypp
        functionspace/atlas_functionspace_StructuredColumns_module.F90
        functionspace/atlas_functionspace_Spectral_module.F90
        functionspace/atlas_functionspace_PointCloud_module.F90
        field/atlas_FieldSet_module.F90
        field/atlas_State_module.F90
        field/atlas_Field_module.fypp
        grid/atlas_Grid_module.F90
        grid/atlas_GridDistribution_module.F90
        grid/atlas_Vertical_module.F90
        grid/atlas_Partitioner_module.F90
        mesh/atlas_MeshGenerator_module.F90
        mesh/atlas_Mesh_module.F90
        mesh/atlas_mesh_Nodes_module.F90
        mesh/atlas_mesh_Edges_module.F90
        mesh/atlas_mesh_Cells_module.F90
        mesh/atlas_Connectivity_module.F90
        mesh/atlas_HybridElements_module.F90
        mesh/atlas_Elements_module.F90
        mesh/atlas_ElementType_module.F90
        mesh/atlas_mesh_actions_module.F90
        numerics/atlas_Method_module.F90
        numerics/atlas_fvm_module.F90
        numerics/atlas_Nabla_module.F90
        interpolation/atlas_Interpolation_module.F90
        parallel/atlas_GatherScatter_module.fypp
        parallel/atlas_Checksum_module.fypp
        parallel/atlas_HaloExchange_module.fypp
        projection/atlas_Projection_module.F90
        trans/atlas_Trans_module.F90
        internals/atlas_read_file.h
        internals/atlas_read_file.cc
        internals/Library.h
        internals/Library.cc
        runtime/atlas_trace.cc
        runtime/atlas_Trace_module.F90

  PRIVATE_INCLUDES
        ${FCKIT_INCLUDE_DIRS}
)

target_link_libraries( atlas_f PUBLIC
  $<LINK_ONLY:atlas> )

target_link_libraries( atlas_f PUBLIC
  fckit )

if( atlas_HAVE_OMP_Fortran )
  target_link_libraries( atlas_f PRIVATE OpenMP::OpenMP_Fortran )
endif()

target_include_directories( atlas_f PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}>
  $<INSTALL_INTERFACE:include>
  $<INSTALL_INTERFACE:module/atlas>
)
target_include_directories( atlas_f PRIVATE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
)
if( ECKIT_INCLUDE_DIRS )
  target_include_directories( atlas_f PRIVATE ${ECKIT_INCLUDE_DIRS} )
endif()

fckit_target_preprocess_fypp( atlas_f
  DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.h.in
    ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.fypp
    ${CMAKE_CURRENT_SOURCE_DIR}/internals/atlas_generics.fypp )

=== eckit/src/eckit/CMakeLists.txt ===
### endianess

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
        set( ECKIT_BIG_ENDIAN    1 )
        set( ECKIT_LITTLE_ENDIAN 0 )
else()
        set( ECKIT_BIG_ENDIAN    0 )
        set( ECKIT_LITTLE_ENDIAN 1 )
endif()

set( ECKIT_BIG_ENDIAN    ${ECKIT_BIG_ENDIAN}    )
set( ECKIT_LITTLE_ENDIAN ${ECKIT_LITTLE_ENDIAN} )

### check support for DL library

check_include_files( dlfcn.h  ECKIT_HAVE_DLFCN_H )

cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS} )
    check_c_source_compiles( "#define _GNU_SOURCE\n#include <dlfcn.h>\nint main(){ void* addr; Dl_info info; dladdr(addr, &info); }\n"
        ECKIT_HAVE_DLADDR )
cmake_pop_check_state()

### system headers and symbols tests for eckit config headers

check_symbol_exists( MAP_ANONYMOUS "sys/mman.h"  ECKIT_HAVE_MAP_ANONYMOUS )
check_symbol_exists( MAP_ANON      "sys/mman.h"  ECKIT_HAVE_MAP_ANON )
check_symbol_exists( funopen       "stdio.h"     ECKIT_HAVE_FUNOPEN )
check_symbol_exists( fsync         "unistd.h"    ECKIT_HAVE_FSYNC)
check_symbol_exists( fdatasync     "unistd.h"    ECKIT_HAVE_FDATASYNC)
check_symbol_exists( F_FULLFSYNC   "fcntl.h"     ECKIT_HAVE_F_FULLFSYNC)
check_symbol_exists( fmemopen      "stdio.h"     ECKIT_HAVE_FMEMOPEN )

check_c_source_compiles( "#define _GNU_SOURCE\n#include <stdio.h>\nint main(){ void* cookie; const char* mode; cookie_io_functions_t iof; FILE* fopencookie(void *cookie, const char *mode, cookie_io_functions_t iof); }"
    ECKIT_HAVE_FOPENCOOKIE )

check_c_source_compiles( "#include <unistd.h>\n#include <execinfo.h>\n int main(){ void ** buffer; int i = backtrace(buffer, 256); }\n"
    ECKIT_HAVE_EXECINFO_BACKTRACE )

check_cxx_source_compiles( "#include <cxxabi.h>\n int main() { char * type; int status; char * r = abi::__cxa_demangle(type, 0, 0, &status); }"
    ECKIT_HAVE_CXXABI_H )

check_c_source_compiles( "#include <time.h>\nint main(){ time_t now; time(&now); struct tm t; gmtime_r(&now,&t); }\n"
    ECKIT_HAVE_GMTIME_R )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; struct dirent **result; int i = readdir_r(dirp, entry, result); }\n"
    ECKIT_HAVE_READDIR_R )

check_c_source_compiles( "#include <sys/types.h>\n#include <dirent.h>\nint main(){ DIR *dirp; int i = dirfd(dirp); }\n"
    ECKIT_HAVE_DIRFD )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; if(entry->d_type) { dirp = 0; } }\n"
    ECKIT_HAVE_DIRENT_D_TYPE )

check_cxx_source_compiles( "int main() { __int128 i = 0; return 0;}"
    ECKIT_HAVE_CXX_INT_128 )

### config headers

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_config.h.in   eckit_config.h  )
configure_file( eckit_version.h.in  eckit_version.h )

install(FILES
			${CMAKE_CURRENT_BINARY_DIR}/eckit_config.h
			${CMAKE_CURRENT_BINARY_DIR}/eckit_version.h
		DESTINATION
			${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_version.cc.in  eckit_version.cc )

### eckit sources

list( APPEND eckit_srcs eckit.h deprecated.h eckit_version.cc )

list( APPEND eckit_container_srcs

container/BSPTree.h
container/BTree.cc
container/BTree.h
container/BloomFilter.cc
container/BloomFilter.h
container/Cache.h
container/CacheLRU.cc
container/CacheLRU.h
container/CacheManager.cc
container/CacheManager.h
container/ClassExtent.h
container/DenseMap.h
container/DenseSet.h
container/KDMapped.cc
container/KDMapped.h
container/KDMemory.h
container/KDTree.h
container/MappedArray.cc
container/MappedArray.h
container/Queue.h
container/Recycler.h
container/SharedMemArray.cc
container/SharedMemArray.h
container/StatCollector.h
container/Trie.cc
container/Trie.h
container/bsptree/BSPHyperPlane.h
container/bsptree/BSPNode.cc
container/bsptree/BSPNode.h
container/kdtree/KDNode.cc
container/kdtree/KDNode.cc
container/kdtree/KDNode.h
container/sptree/SPIterator.h
container/sptree/SPMetadata.h
container/sptree/SPNode.h
container/sptree/SPNodeInfo.h
container/sptree/SPNodeQueue.h
container/sptree/SPTree.h
container/sptree/SPValue.h
)

list( APPEND eckit_io_srcs
io/AsyncHandle.cc
io/AsyncHandle.h
io/AIOHandle.cc
io/AIOHandle.h
io/AutoCloser.h
io/Base64.cc
io/Base64.h
io/BitIO.cc
io/BitIO.h
io/Buffer.cc
io/Buffer.h
io/BufferCache.cc
io/BufferCache.h
io/BufferedHandle.cc
io/BufferedHandle.h
io/CircularBuffer.cc
io/CircularBuffer.h
io/CommandStream.cc
io/CommandStream.h
io/Compress.cc
io/Compress.h
io/DataBlob.cc
io/DataBlob.h
io/DataHandle.cc
io/DataHandle.h
io/DblBuffer.cc
io/DblBuffer.h
io/EmptyHandle.cc
io/EmptyHandle.h
io/FDataSync.cc
io/FDataSync.h
io/FTPHandle.cc
io/FTPHandle.h
io/FileBase.cc
io/FileBase.h
io/FileDescHandle.cc
io/FileDescHandle.h
io/FileHandle.cc
io/FileHandle.h
io/MMappedFileHandle.cc
io/MMappedFileHandle.h
io/FileLock.cc
io/FileLock.h
io/FileLocker.cc
io/FileLocker.h
io/FilePool.cc
io/FilePool.h
io/FileHandle.cc
io/FileHandle.h
io/HandleBuf.cc
io/HandleBuf.h
io/HandleHolder.cc
io/HandleHolder.h
io/Length.cc
io/Length.h
io/MarsFSHandle.cc
io/MarsFSHandle.h
io/MemoryHandle.cc
io/MemoryHandle.h
io/MoverTransfer.cc
io/MoverTransfer.h
io/MultiHandle.cc
io/MultiHandle.h
io/Offset.cc
io/Offset.h
io/PartFileHandle.cc
io/PartFileHandle.h
io/PartHandle.cc
io/PartHandle.h
io/PipeHandle.cc
io/PipeHandle.h
io/Pipeline.cc
io/Pipeline.h
io/PooledFile.cc
io/PooledFile.h
io/PooledHandle.cc
io/PooledHandle.h
io/PooledFileDescriptor.cc
io/PooledFileDescriptor.h
io/RawFileHandle.cc
io/RawFileHandle.h
io/ResizableBuffer.cc
io/ResizableBuffer.h
io/Select.cc
io/Select.h
io/SharedBuffer.cc
io/SharedBuffer.h
io/SharedHandle.cc
io/SharedHandle.h
io/SockBuf.cc
io/SockBuf.h
io/StatsHandle.cc
io/StatsHandle.h
io/StdFile.cc
io/StdFile.h
io/StdFileHandle.cc
io/StdFileHandle.h
io/StdPipe.cc
io/StdPipe.h
io/StdioBuf.cc
io/StdioBuf.h
io/TCPHandle.cc
io/TCPHandle.h
io/TCPSocketHandle.cc
io/TCPSocketHandle.h
io/TeeHandle.cc
io/TeeHandle.h
io/TransferWatcher.cc
io/TransferWatcher.h
io/cluster/ClusterDisks.cc
io/cluster/ClusterDisks.h
io/cluster/ClusterNode.cc
io/cluster/ClusterNode.h
io/cluster/ClusterNodes.cc
io/cluster/ClusterNodes.h
io/cluster/NodeInfo.cc
io/cluster/NodeInfo.h
)

if(HAVE_CURL)
list(APPEND eckit_io_srcs
io/EasyCURL.cc
io/EasyCURL.h
io/URLHandle.cc
io/URLHandle.h)
endif()


if(HAVE_RADOS)
list( APPEND eckit_io_srcs
io/rados/RadosHandle.cc
io/rados/RadosHandle.h
io/rados/RadosCluster.h
io/rados/RadosCluster.cc
io/rados/RadosReadHandle.cc
io/rados/RadosReadHandle.h
io/rados/RadosWriteHandle.cc
io/rados/RadosWriteHandle.h
io/rados/RadosObject.h
io/rados/RadosObject.cc
io/rados/RadosAttributes.h
io/rados/RadosAttributes.cc
)
endif()

list( APPEND eckit_filesystem_srcs
filesystem/BasePathName.cc
filesystem/BasePathName.h
filesystem/BasePathNameT.cc
filesystem/BasePathNameT.h
filesystem/FileMode.cc
filesystem/FileMode.h
filesystem/FileSpace.cc
filesystem/FileSpace.h
filesystem/FileSpaceStrategies.cc
filesystem/FileSpaceStrategies.h
filesystem/FileSystem.cc
filesystem/FileSystem.h
filesystem/FileSystemSize.h
filesystem/LocalPathName.cc
filesystem/LocalPathName.h
filesystem/PathExpander.cc
filesystem/PathExpander.h
filesystem/PathName.cc
filesystem/PathName.h
filesystem/TempFile.cc
filesystem/TempFile.h
filesystem/TmpDir.cc
filesystem/TmpDir.h
filesystem/TmpFile.cc
filesystem/TmpFile.h
filesystem/URI.cc
filesystem/URI.h
filesystem/URIManager.cc
filesystem/URIManager.h
filesystem/marsfs/MarsFSClient.cc
filesystem/marsfs/MarsFSClient.h
filesystem/marsfs/MarsFSFile.cc
filesystem/marsfs/MarsFSFile.h
filesystem/marsfs/MarsFSPath.cc
filesystem/marsfs/MarsFSPath.h
)

list( APPEND eckit_thread_srcs
    thread/AutoLock.h
    thread/Mutex.cc
    thread/Mutex.h
    thread/MutexCond.cc
    thread/MutexCond.h
    thread/Once.h
    thread/StaticMutex.cc
    thread/StaticMutex.h
    thread/Thread.cc
    thread/Thread.h
    thread/ThreadControler.cc
    thread/ThreadControler.h
    thread/ThreadPool.cc
    thread/ThreadPool.h
    thread/ThreadSingleton.h
)

list( APPEND eckit_config_srcs
config/Configurable.cc
config/Configurable.h
config/Configuration.cc
config/Configuration.h
config/Configured.cc
config/Configured.h
config/EtcTable.cc
config/EtcTable.h
config/JSONConfiguration.h
config/LibEcKit.cc
config/LibEcKit.h
config/LocalConfiguration.cc
config/LocalConfiguration.h
config/Parametrisation.cc
config/Parametrisation.h
config/Resource.h
config/ResourceBase.cc
config/ResourceBase.h
config/ResourceMgr.cc
config/ResourceMgr.h
config/YAMLConfiguration.cc
config/YAMLConfiguration.h
)

list( APPEND eckit_runtime_srcs
runtime/Application.cc
runtime/Application.h
runtime/Dispatcher.h
runtime/Library.cc
runtime/Library.h
runtime/Main.cc
runtime/Main.h
runtime/Monitor.cc
runtime/Monitor.h
runtime/Monitorable.cc
runtime/Monitorable.h
runtime/Pipe.h
runtime/PipeApplication.cc
runtime/PipeApplication.h
runtime/PipeHandler.cc
runtime/PipeHandler.h
runtime/ProcessControler.cc
runtime/ProcessControler.h
runtime/ProducerConsumer.h
runtime/Telemetry.cc
runtime/Telemetry.h
runtime/SessionID.cc
runtime/SessionID.h
runtime/Task.cc
runtime/Task.h
runtime/TaskID.h
runtime/TaskInfo.cc
runtime/TaskInfo.h
runtime/Tool.cc
runtime/Tool.h
)

list( APPEND eckit_log_srcs
log/BigNum.cc
log/BigNum.h
log/Bytes.cc
log/Bytes.h
log/CallbackTarget.cc
log/CallbackTarget.h
log/Channel.cc
log/Channel.h
log/ChannelBuffer.cc
log/ChannelBuffer.h
log/CodeLocation.cc
log/CodeLocation.h
log/Colour.cc
log/Colour.h
log/ColouringTarget.cc
log/ColouringTarget.h
log/ETA.cc
log/ETA.h
log/FileTarget.cc
log/FileTarget.h
log/IndentTarget.cc
log/IndentTarget.h
log/JSON.cc
log/JSON.h
log/LineBasedTarget.cc
log/LineBasedTarget.h
log/Log.cc
log/Log.h
log/LogTarget.cc
log/LogTarget.h
log/MessageTarget.cc
log/MessageTarget.h
log/MonitorTarget.cc
log/MonitorTarget.h
log/Number.cc
log/Number.h
log/OStreamTarget.cc
log/OStreamTarget.h
log/Plural.h
log/PrefixTarget.cc
log/PrefixTarget.h
log/Progress.cc
log/Progress.h
log/ProgressTimer.cc
log/ProgressTimer.h
log/ResourceUsage.cc
log/ResourceUsage.h
log/RotationTarget.cc
log/RotationTarget.h
log/SavedStatus.cc
log/SavedStatus.h
log/Seconds.cc
log/Seconds.h
log/Statistics.cc
log/Statistics.h
log/StatusTarget.cc
log/StatusTarget.h
log/SysLog.cc
log/SysLog.h
log/TeeTarget.cc
log/TeeTarget.h
log/TimeStamp.cc
log/TimeStamp.h
log/TimeStampTarget.cc
log/TimeStampTarget.h
log/Timer.cc
log/Timer.h
log/TraceTimer.h
log/UserChannel.cc
log/UserChannel.h
log/WrapperTarget.cc
log/WrapperTarget.h
)

list( APPEND eckit_exception_srcs
exception/Exceptions.cc
exception/Exceptions.h
)

list( APPEND eckit_types_srcs
types/ClimateDate.cc
types/ClimateDate.h
types/Coord.cc
types/Coord.h
types/Date.cc
types/Date.h
types/DateTime.cc
types/DateTime.h
types/DayOfYear.cc
types/DayOfYear.h
types/Double.cc
types/Double.h
types/FixedString.h
types/FloatCompare.cc
types/FloatCompare.h
types/Fraction.cc
types/Fraction.h
types/Grid.cc
types/Grid.h
types/Metadata.cc
types/Metadata.h
types/Month.cc
types/Month.h
types/Time.cc
types/Time.h
types/TimeInterval.cc
types/TimeInterval.h
types/Types.cc
types/Types.h
types/UUID.cc
types/UUID.h
types/VerifyingDate.cc
types/VerifyingDate.h
)

list( APPEND eckit_parser_srcs
parser/CSVParser.cc
parser/CSVParser.h
parser/JSON.h
parser/JSONDataBlob.cc
parser/JSONDataBlob.h
parser/JSONMetadata.cc
parser/JSONMetadata.h
parser/JSONParser.cc
parser/JSONParser.h
parser/ObjectParser.cc
parser/ObjectParser.h
parser/StreamParser.cc
parser/StreamParser.h
parser/YAMLParser.cc
parser/YAMLParser.h
)

list( APPEND eckit_value_srcs
value/BoolContent.cc
value/BoolContent.h
value/CompositeParams.cc
value/CompositeParams.h
value/Content.cc
value/Content.h
value/DateContent.cc
value/DateContent.h
value/DateTimeContent.cc
value/DateTimeContent.h
value/DispatchParams.h
value/DoubleContent.cc
value/DoubleContent.h
value/Expression.h
value/ListContent.cc
value/ListContent.h
value/MapContent.cc
value/MapContent.h
value/NilContent.cc
value/NilContent.h
value/NumberContent.cc
value/NumberContent.h
value/OrderedMapContent.cc
value/OrderedMapContent.h
value/Params.cc

=== eckit/tests/io/CMakeLists.txt ===
### test data files
list( APPEND test_data_files
t.grib
)

if(HAVE_EXTRA_TESTS)
    ecbuild_get_test_multidata( TARGET get_eckit_io_test_data
                                NAMES ${test_data_files}
                                NOCHECK )
endif()

ecbuild_add_test( TARGET   eckit_test_filepool
                  SOURCES  test_filepool.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET  eckit_test_datablob
                  SOURCES test_datablob.cc
                  LIBS    eckit )

ecbuild_add_test( TARGET  eckit_test_urlhandle
                  SOURCES test_urlhandle.cc
                  CONDITION ECKIT_HAVE_CURL AND OFF
                  LIBS    eckit )

ecbuild_add_test( TARGET  eckit_test_circularbuffer
                  SOURCES test_circularbuffer.cc
                  LIBS    eckit )

ecbuild_add_test( TARGET      eckit_test_compress
                  SOURCES     test_compress.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_bitio
                  SOURCES     test_bitio.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_base64
                  SOURCES     test_base64.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_multihandle
                  SOURCES     test_multihandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_partfilehandle
                  SOURCES     test_partfilehandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_pooledfile
                  SOURCES     test_pooledfile.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_pooledhandle
                  SOURCES     test_pooledhandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_radoshandle
                  SOURCES     test_radoshandle.cc
                  CONDITION   HAVE_RADOS
                  INCLUDES    ${RADOS_INCLUDE_DIRS}
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_rados-performance
                  SOURCES     rados-performance.cc
                  CONDITION   (HAVE_EXTRA_TESTS AND HAVE_RADOS)
                  INCLUDES    ${RADOS_INCLUDE_DIRS}
                  TEST_DEPENDS get_eckit_io_test_data
                  LIBS        eckit )

=== mars-client/src/tools/CMakeLists.txt ===
list( APPEND mars_tools_bins marsgen bufr2request check_fs obscmp prearcbufr reqmerge reqcheck grib2request)

foreach( tool ${mars_tools_bins} )

    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.c
                            INCLUDES   ${GRIB_API_INCLUDE_DIRS}
                            LIBS       marsclient )

endforeach()

ecbuild_add_executable( TARGET     ecmars
                        SOURCES    ecmars.c
                        CONDITION  HAVE_RPC
                        INCLUDES   ${GRIB_API_INCLUDE_DIRS}
                        LIBS       marsclient )

ecbuild_debug()

ecbuild_add_executable( TARGET     bufrbitcmp
                        CONDITION  HAVE_BUFR_TOOLS AND LIBEMOS_HAVE_LIBEMOS_BUFRDC
                        SOURCES    bufrbitcmp.cc ObsKey.cc ObsKey.h
                        LIBS       marsclient emos )


ecbuild_add_executable( TARGET     cube
                        SOURCES    cube.cc )

# this executable only makes sense under the previous FDB 4.x series

ecbuild_info("HAVE_LIBEMOS [${HAVE_LIBEMOS}]")

ecbuild_add_executable( TARGET     grib2fdb4
                        SOURCES    grib2fdb.c
                        CONDITION  HAVE_FDB AND fdb_VERSION VERSION_LESS 5.0
                        INCLUDES   ${GRIB_API_INCLUDE_DIRS}
                        LIBS       marsclient )

ecbuild_add_executable( TARGET     makedb_bufr
                        SOURCES    makedb_bufr.c
                        CONDITION  HAVE_FDB AND fdb_VERSION VERSION_LESS 5.0
                        INCLUDES   ${GRIB_API_INCLUDE_DIRS}
                        LIBS       marsclient )

ecbuild_add_executable( TARGET     filterbufr
                        SOURCES    filterbufr.c
                        CONDITION  HAVE_BUFR_TOOLS AND LIBEMOS_HAVE_LIBEMOS_BUFRDC
                        INCLUDES   ${GRIB_API_INCLUDE_DIRS}
                        LIBS       marsclient emos )

ecbuild_add_executable( TARGET     ncmerge
						SOURCES    ncmerge.cc Attribute.cc Attribute.h Dimension.cc Dimension.h
						Exceptions.h Exceptions.cc Endowed.cc Endowed.h InputField.cc InputField.h
                        OutputField.cc OutputField.h Matrix.h Matrix.cc MergeDataMatrix.h MergeDataMatrix.cc
                        MergeCoordinateMatrix.h MergeCoordinateMatrix.cc
                        InputMatrix.h InputMatrix.cc
			            Counted.h Counted.cc
                        DummyMatrix.h DummyMatrix.cc
                        DummyInputVariable.h DummyInputVariable.cc
                        Reshape.h Reshape.cc
                        InputAttribute.cc InputAttribute.h
                        InputDimension.cc InputDimension.h InputVariable.cc InputVariable.h
			            VirtualInputDimension.h VirtualInputDimension.cc
			            VirtualOutputDimension.h VirtualOutputDimension.cc
                        OutputAttribute.cc OutputAttribute.h OutputDimension.cc OutputDimension.h OutputVariable.cc OutputVariable.h
                        DataInputVariable.cc DataInputVariable.h
                        DataOutputVariable.cc DataOutputVariable.h
                        Remapping.h Remapping.cc
                        SimpleInputVariable.cc
                        SimpleInputVariable.h
                        SimpleOutputVariable.cc
                        SimpleOutputVariable.h
                        CellMethodInputVariable.cc
                        CellMethodInputVariable.h
                        CellMethodOutputVariable.cc
                        CellMethodOutputVariable.h
                        Codec.cc Codec.h Mapper.h
                        GregorianDateCodec.h
                        GregorianDateCodec.cc
                        Tokenizer.cc Tokenizer.h Date.cc Time.cc Time.h Date.h DateTime.cc DateTime.h
                        Translator.h Translator.cc Seconds.cc Seconds.h
                        NCFile.h NCFile.cc NCFileCache.h NCFileCache.cc
                        CoordinateOutputVariable.cc CoordinateOutputVariable.h
                        ScalarCoordinateOutputVariable.cc ScalarCoordinateOutputVariable.h
                        CoordinateInputVariable.h CoordinateInputVariable.cc
                        ScalarCoordinateInputVariable.h ScalarCoordinateInputVariable.cc
                        Step.h Step.cc
                        MergePlan.h MergePlan.cc MergeDataStep.h MergeDataStep.cc
                        MergeCoordinateStep.h MergeCoordinateStep.cc
                        UpdateCoordinateStep.h UpdateCoordinateStep.cc
                        ReshapeVariableStep.cc ReshapeVariableStep.h HyperCube.cc HyperCube.h
                        Field.cc Field.h Type.cc Type.h Value.cc Value.h Variable.cc Variable.h ncmerge.cc
						CONDITION  HAVE_NETCDF
                        INCLUDES   ${NETCDF_INCLUDE_DIRS}
						LIBS       ${NETCDF_LIBRARIES} )

ecbuild_add_executable( TARGET     nctest
                        SOURCES    nctest.c
                        CONDITION  HAVE_NETCDF
                        INCLUDES   ${NETCDF_INCLUDE_DIRS}
                        LIBS       ${NETCDF_LIBRARIES} )

ecbuild_add_executable( TARGET     netcdf2request
                        SOURCES    netcdf2request.c
                        CONDITION  HAVE_NETCDF
                        INCLUDES   ${NETCDF_INCLUDE_DIRS}  ${GRIB_API_INCLUDE_DIRS}
                        LIBS       marsclient ${NETCDF_LIBRARIES} )


file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/nccompare.py
  DESTINATION ${CMAKE_BINARY_DIR}/bin
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE )

# two_dimensions_merge
list(APPEND merge_tests_ok simple_two_way_merge
        simple_three_way_merge
        complex_two_way_merge
        type_upgrade_merge
        attribute_merge
        multi_merge
        multi_dimensions_merge
        signature_merge_1
        signature_merge_2
        new_missing_values_merge
        new_dimension_merge_1
        new_dimension_merge_2
        retype_merge
        coordinates_overlap_merge_1
        coordinates_overlap_merge_2
        coordinates_overlap_merge_3
        coordinates_overlap_merge_4
        coordinates_overlap_merge_5
        coordinates_overlap_merge_6
        date_merge_1
        date_merge_2
        variable_merge_1
        variable_merge_2
        variable_merge_3
        variable_merge_4
        variable_merge_5
        bounds_merge_1
        bounds_merge_2
        monotonic
        )

list(APPEND merge_tests_fail bounds_merge)
list(APPEND merge_tests_only coordinates_overlap_merge)

find_program(NCGEN ncgen
  HINTS
    ${NETCDF_ROOT} ${NETCDF_DIR} ${NETCDF_PATH} ${NETCDF4_DIR}
  ENV
    NETCDF_ROOT NETCDF_DIR NETCDF_PATH
    NETCDF4_ROOT NETCDF4_PATH NETCDF4_DIR
    NETCDF NETCDF4)
find_program(NCDUMP ncdump
  HINTS
    ${NETCDF_ROOT} ${NETCDF_DIR} ${NETCDF_PATH} ${NETCDF4_DIR}
  ENV
    NETCDF_ROOT NETCDF_DIR NETCDF_PATH
    NETCDF4_ROOT NETCDF4_PATH NETCDF4_DIR
    NETCDF NETCDF4)

foreach(_TEST
    #bounds_merge_2
    # ${merge_tests_ok}
    )
    ecbuild_add_test(TARGET "nccombine_${_TEST}"
                     CONDITION  HAVE_NETCDF AND NCGEN AND NCDUMP
                     ENVIRONMENT
                         BINDIR=${CMAKE_BINARY_DIR}/bin
                         NCGEN=${NCGEN}
                         NCDUMP=${NCDUMP}
                     COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/${_TEST}.sh")
endforeach()

=== metview/src/codes_ui/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.6.0 FATAL_ERROR )

project( codes_ui LANGUAGES C CXX VERSION 1.3.3)

# All executables and scripts apart from the startup script should go into MV_BIN_DIR.
# Users can override by setting METVIEW_INSTALL_EXE_BIN_DIR.
# It should be relative to the root of the install directory.
#if(DEFINED METVIEW_INSTALL_EXE_BIN_DIR)
#    set(MV_BIN_DIR ${METVIEW_INSTALL_EXE_BIN_DIR})
#else()
#    set(MV_BIN_DIR bin/metview_bin)
#endif()

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake"  "${CMAKE_CURRENT_SOURCE_DIR}/../../../ecbuild/cmake")
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE OFF)

#set(METVIEW_INSTALL_BIN_DIR "${MV_BIN_DIR}" CACHE PATH "Metview installation directory for executable files")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.9 )

###############################################################################
# some options of this project

option( ENABLE_QT_DEBUG      "enable Qt debugging messages"                       OFF )

###############################################################################

#C check if it is an exeternal build (outside the metview source)
set(__external_build  1)
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../AppMod")
   set(__external_build 0)
endif()

# ensure we can add non-existent dependencies - required for generating icon files
if( ${CMAKE_VERSION} VERSION_GREATER "2.9.9" )
    cmake_policy(SET CMP0046 OLD)
endif()

if(DEFINED EXTRA_CONFIG_PATH)
    message(STATUS "Will search ${EXTRA_CONFIG_PATH} for additional config files")
endif()


# default startup script name
if(NOT DEFINED CODES_UI_SCRIPT )
    set( CODES_UI_SCRIPT "codes_ui" )
endif()

set(FULL_STARTUP_SCRIPT_PATH ${CMAKE_BINARY_DIR}/bin/${CODES_UI_SCRIPT})

# ensure we don't build shared libraries
set(BUILD_SHARED_LIBS OFF)

message("CMAKE_BINARY_DIR = ${CMAKE_BINARY_DIR}")
message("CMAKE_CURRENT_SOURCE_DIR = ${CMAKE_CURRENT_SOURCE_DIR}")
message("CPACK_SOURCE_IGNORE_FILES = ${CPACK_SOURCE_IGNORE_FILES}")


###############################################################################
# local project requirements

#ecbuild_add_option( FEATURE ECCODES DESCRIPTION "" DEFAULT OFF )

ecbuild_use_package( PROJECT eccodes VERSION 2.16.0 REQUIRED )
set( GRIB_API_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS} )
set( GRIB_API_LIBRARIES    ${ECCODES_LIBRARIES} )
set( GRIB_API_DEFINITIONS  ${ECCODES_DEFINITIONS} )
set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
add_definitions(-DGRIB_HANDLING_PACKAGE=ecCodes)

ecbuild_declare_project()

###############################################################################
# Find external dependencies

#Qt5
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5XmlPatterns REQUIRED)
find_package(Qt5Svg REQUIRED)

if( Qt5Widgets_FOUND )
    message(STATUS "Qt5 version ${Qt5Widgets_VERSION_STRING} was found")
    include_directories(${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Xml_INCLUDE_DIRS} ${Qt5XmlPatterns_INCLUDE_DIRS} ${Qt5Svg_INCLUDE_DIRS})
    set( METVIEW_QT 1)
    set( METVIEW_QT5 true)
        add_definitions( -DMETVIEW_QT5 )
    else()
        message(FATAL_ERROR "Qt5 was NOT found ...")
endif()


if( NOT ENABLE_QT_DEBUG )
    add_definitions( -DQT_NO_DEBUG_OUTPUT )
endif()


###############################################################################
# contents
######set( METVIEW_TPLS grib_api odb_api EXPAT NetCDF PangoCairo Proj4 libemos)

#When we build outside the ecmwf dev environment (i.e. from the tarball) we have
#a different directory structure.
if(__external_build)    
    set(SRC_PATH ${CMAKE_CURRENT_SOURCE_DIR}/src)
    set(SHARE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/share/codes_ui/etc)
    set(STARTUP_SCRIPT_TEMPLATE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/scripts/codes_ui_base.in")
    set(WINDOWS_STARTUP_SCRIPT_PATH "${CMAKE_CURRENT_SOURCE_DIR}/codes_ui.bat")
    set(KEYPROFILE_PATH ${SHARE_PATH})
    set(VERSION_PATH ${SHARE_PATH})
    set(EXE_SRC_PATH ${CMAKE_CURRENT_SOURCE_DIR}/src/codes_ui)
    set(LIBCODESUI_SRC_PATH "${SRC_PATH}/libCodesUi")
else()
    set(SRC_PATH "..")
    set(SHARE_PATH "../../share/metview/app-defaults")
    set(STARTUP_SCRIPT_TEMPLATE_PATH "codes_ui_base.in")
    set(WINDOWS_STARTUP_SCRIPT_PATH "codes_ui.bat")
    set(KEYPROFILE_PATH ".")
    set(VERSION_PATH ".")
    set(EXE_SRC_PATH ".")
    set(LIBCODESUI_SRC_PATH ".")
endif()

message(STATUS ${__external_build})
message(STATUS ${CMAKE_CURRENT_SOURCE_DIR})

set( METVIEW_STANDARD_INCLUDE_DIRS        
        ${SRC_PATH}/libFTimeUtil
        ${SRC_PATH}/libMetview
        ${LIBCODESUI_SRC_PATH}
        ${SRC_PATH}/BufrExaminer
        ${SRC_PATH}/GribExaminer
        .
       )
set(STANDARD_METVIEW_LIBS Metview FTimeUtil CodesUi)

# only want certain third-party libraries linked with all modules - the rest
# are on a per-module basis
set(METVIEW_TPLS eccodes)
foreach( _tpl ${METVIEW_TPLS} )
    string( TOUPPER ${_tpl} TPL )
    list( APPEND METVIEW_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS}  )
    list( APPEND METVIEW_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} )
    list( APPEND METVIEW_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} )
    message(STATUS "xTPL_LIBRARIES: ${TPL}_LIBRARIES")
endforeach()


###list( APPEND METVIEW_EXTRA_DEFINITIONS   fortfloat=double fortint=int boolean=bool )

list( APPEND METVIEW_QT_INCLUDE_DIRS ${Qt5Widgets_INCLUDE_DIR} ${Qt5Gui_INCLUDE_DIR} ${Qt5Network_INCLUDE_DIR} ${Qt5Xml_INCLUDE_DIR} ${Qt5XmlPatterns_INCLUDE_DIR}  ${Qt5Svg_INCLUDE_DIR} ${SRC_PATH}/libMvQtUtil ${SRC_PATH}/libMvQtGui  )
list( APPEND METVIEW_QT_LIBRARIES  MvQtGui MvQtUtil ${Qt5Widgets_LIBRARIES} ${Qt5Gui_LIBRARIES} ${Qt5Network_LIBRARIES} ${Qt5Xml_LIBRARIES} ${Qt5XmlPatterns_LIBRARIES} ${Qt5Svg_LIBRARIES})

message(STATUS "METVIEW_EXTRA_DEFINITIONS  => ${METVIEW_EXTRA_DEFINITIONS}")
message(STATUS "METVIEW_EXTRA_INCLUDE_DIRS => ${METVIEW_EXTRA_INCLUDE_DIRS}")
message(STATUS "METVIEW_EXTRA_LIBRARIES    => ${METVIEW_EXTRA_LIBRARIES}")
message(STATUS "STANDARD_METVIEW_LIBS      => ${STANDARD_METVIEW_LIBS}")


# we need to make sure that
#set(CMAKE_INCLUDE_DIRECTORIES_BEFORE "ON")

###include_directories( ${METVIEW_INCLUDE_DIRS} ${METVIEW_EXTRA_INCLUDE_DIRS} )
set(METVIEW_STANDARD_INCLUDES ${METVIEW_STANDARD_INCLUDE_DIRS} ${METVIEW_EXTRA_INCLUDE_DIRS} )
link_directories( ${CMAKE_CURRENT_SOURCE_DIR}/lib )
message(STATUS "METVIEW_STANDARD_INCLUDE_DIRS  => ${METVIEW_STANDARD_INCLUDES}")


set(  __metview_inc_tmp ${METVIEW_EXTRA_INCLUDE_DIRS} )
set(METVIEW_EXTRA_INCLUDES "")

foreach( inc ${__metview_inc_tmp} )
  set(METVIEW_EXTRA_INCLUDES "${METVIEW_EXTRA_INCLUDES} -I${inc}" )
endforeach()

add_definitions( -DR64 -DECCODES_UI -DH_INCLUDES_CC -DUSE_NEW_IO )

# ecbuild automatically test endiness and sets variable EC_BIG_ENDIAN or EC_LITTLE_ENDIAN
if( EC_LITTLE_ENDIAN )
    add_definitions(-DLITTLE_END) # needed for libMars/bufr.h
endif()

# -------------------------
# compiler-specific options
# -------------------------

if     (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" )
    ecbuild_add_cxx_flags("-fpermissive -Wno-write-strings -Wno-deprecated")
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" )
    ecbuild_add_cxx_flags("-fpermissive -Wno-deprecated -undefined dynamic_lookup")
endif()

if     (CMAKE_C_COMPILER_ID STREQUAL "Clang" )
    ecbuild_add_c_flags("-undefined dynamic_lookup")     #  "-fno-common  -mmacosx-version-min=10.8")
endif()

if( EC_OS_NAME MATCHES "windows" )
    # Suppress compiler warnings
    # Suppress warnings about using 'insecure' functions.
    ecbuild_add_cxx_flags("/D_CRT_SECURE_NO_WARNINGS")
    # Suppress warnings about using well-known C functions.
    ecbuild_add_cxx_flags("/D_CRT_NONSTDC_NO_DEPRECATE")
    # Suppress C4267: warns about possible loss of data when converting 'size_t' to 'int'.
    ecbuild_add_cxx_flags("/wd4267")
endif()

macro(add_files_to_tar FILES TAR_DIR)

    if(NOT __external_build)

        message(STATUS "add_files_to_tar()")
        message(STATUS "TAR_DIR=${TAR_DIR}")

        set(tmpdir $ENV{TMPDIR}/codes_ui_tar_tmp/${TAR_DIR})
        message(STATUS "tmpdir=${tmpdir}")

        file(MAKE_DIRECTORY ${tmpdir})
        foreach( f ${FILES} )
            message(STATUS "  file=${f}")
            file(COPY ${f}
                DESTINATION ${tmpdir}
            )
        endforeach()

        list( APPEND CPACK_SOURCE_INSTALLED_DIRECTORIES
            ${tmpdir} ${TAR_DIR})

        message(STATUS ${CPACK_SOURCE_INSTALLED_DIRECTORIES})

    endif()

endmacro(add_files_to_tar)

#---------------------------------------
# libCodesUi
#---------------------------------------

set(libCodesUi_srcs_names
    CodesDirHandler.cc
    CodesDirHandler.h
)

foreach( f ${libCodesUi_srcs_names} )
   list(APPEND libCodesUi_srcs ${LIBCODESUI_SRC_PATH}/${f})
endforeach()


ecbuild_add_library( TARGET      CodesUi
                     TYPE        STATIC
                     NOINSTALL
                     SOURCES     ${libCodesUi_srcs}
                     TEMPLATES   ${common_templates}
                     INCLUDES    ${METVIEW_STANDARD_INCLUDES} ${LOCAL_EXTRA_INCLUDE_DIRS}
                     DEFINITIONS ${METVIEW_EXTRA_DEFINITIONS}
                     LIBS        ${METVIEW_EXTRA_LIBRARIES}
)

add_files_to_tar("${libCodesUi_srcs}" "src/libCodesUi")

#---------------------------------------
# libFTimeUtil
#---------------------------------------

set(libFTimeUtil_srcs_names
    fdyntime.cc
    fmettim.cc
    fobject.cc
    fsortabl.cc
    fstatime.cc
    fdyntime.h
    fmettim.h
    fobject.h
    fsortabl.h
    fstatime.h

)

foreach( f ${libFTimeUtil_srcs_names} )
   list(APPEND libFTimeUtil_srcs ${SRC_PATH}/libFTimeUtil/${f})
endforeach()

ecbuild_add_library( TARGET      FTimeUtil
                     TYPE        STATIC
                     NOINSTALL
                     SOURCES     ${libFTimeUtil_srcs}
                     TEMPLATES   ${common_templates}
                     INCLUDES    ${METVIEW_STANDARD_INCLUDES}
                     DEFINITIONS ${METVIEW_EXTRA_DEFINITIONS}
                     LIBS        ${METVIEW_EXTRA_LIBRARIES}
)

add_files_to_tar("${libFTimeUtil_srcs}" "src/libFTimeUtil")

#---------------------------------------
# libMetview
#---------------------------------------

set(libMetview_srcs_names
    MvLocation.cc
    MvObs.cc
    MvObsSet.cc  
    BufrFilterDef.cc
    BufrFilterEngine.cc
    BufrLocationCollector.cc
    BufrMetaData.cc
    GribMetaData.cc
    LogHandler.cc
    MvBufrEdition.cc
    MvBufrElementTable.cc
    MvEccBufr.cc
    MvException.cc
    MvKeyCondition.cc
    MvKeyProfile.cc
    MvKeyManager.cc
    MvMessageMetaData.cc
    MvMiscelaneous.cc
    MvTmpFile.cc
    MvVariant.cc
    MvVersionInfo.cc
    Tokenizer.cc
    BufrFilterDef.h
    BufrFilterEngine.h
    BufrLocationCollector.h
    BufrMetaData.h
    FortranTypes.h
    GribMetaData.h
    LogHandler.h
    MvBufrEdition.h
    MvBufrElementTable.h
    MvEccBufr.h
    MvException.h
    MvKeyCondition.h
    MvKeyProfile.h
    MvKeyManager.h
    MvMessageMetaData.h
    MvMiscelaneous.h
    MvTmpFile.h
    MvVariant.h
    MvVersionInfo.h
    Tokenizer.h
    MvBufrObs.h
    MvLocation.h
    MvObs.h
    MvObsSet.h
    MvWindef.h
)

foreach( f ${libMetview_srcs_names} )
   list(APPEND libMetview_srcs ${SRC_PATH}/libMetview/${f})
endforeach()

ecbuild_add_library( TARGET      Metview
                     TYPE        STATIC
                     NOINSTALL
                     SOURCES     ${libMetview_srcs}
                     TEMPLATES   ${common_templates}
                     INCLUDES    ${METVIEW_STANDARD_INCLUDES}
                     DEFINITIONS ${METVIEW_EXTRA_DEFINITIONS}
                     LIBS        ${METVIEW_EXTRA_LIBRARIES}
)



add_files_to_tar("${libMetview_srcs}" "src/libMetview")

#---------------------------------------
# libMvQtGui

=== debian/changelog ===
metview (5.9.1-1) unstable; urgency=medium

  * New upstream release
  * Move to debhelper level 13
  * Switch from autogenerated dh files to using subst. vars
  * Add missing /moved files to d/not-installed

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 26 Jul 2020 12:17:05 +0100

metview (5.9.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 30 Jun 2020 16:49:21 +0100

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  ecbuild (>= 3.3.0-2),
  gfortran | fortran-compiler, 
  python3-all-dev,
  flex, 
  bison, 
  libncurses5-dev,
  libjemalloc-dev,
  libpng-dev,
  libssl-dev,
  libhdf5-dev, 
  liblapack-dev,
  libpango1.0-dev, 
  libfftw3-dev,
  libeigen3-dev,
  chrpath, 
  mksh,
  libqt5webkit5-dev (>= 5.212.0~alpha2-15), 
  qtbase5-dev, libqt5xmlpatterns5-dev,
  libeccodes-dev (>= 2.2.0),
  libeccodes-tools,
  libodb-api-dev (>= 0.18.0-5),
  libatlas-ecmwf-dev (>= 0.19.0-3), 
  libatlas-ecmwf-utils,
  libeckit-dev (>= 1.10.1~),
  libemos-dev (>= 2:4.1.1-2),  libemos-bin,
  libboost-dev, libopenjp2-7-dev,
  libmagics++-metview-dev, 
  libmagics++-dev (>= 4.0.3~),
  libxmu-dev, libgdbm-dev, 
  libcurl4-gnutls-dev,
  libcairo2-dev, 
  pkg-config,
  swig, 
  libexpat1-dev,
  libterralib-dev (>= 4.3.0+dfsg.2-8), 
  libproj-dev, libqt5svg5-dev,
  libgd-dev, 
  imagemagick, 
  libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  flextra, 
  flexpart,
  libgeotiff-dev
Standards-Version: 4.5.0
Homepage: https://software.ecmwf.int/wiki/display/METV/Metview
Vcs-Browser: https://salsa.debian.org:/science-team/metview.git
Vcs-Git: https://salsa.debian.org:/science-team/metview.git

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetview0d (=${binary:Version}),
 x11-utils, metview-data, python3
Recommends: magics++, flextra, flexpart
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview0d
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: libs
Description: Shared libraries  for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides shared libraries and  for  Metview-based software.

Package: libmetview-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmetview0d (=${binary:Version}), 
 libodb-api-dev, libxxhash-dev, libsnappy-dev, liblz4-dev, libbz2-dev
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1


DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# DEB_LDFLAGS_MAINT_PREPEND:= -Wl,-z,defs -Wl,--as-needed
DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-format
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic -fPIC
export DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_PREPEND
export QT_SELECT=5
CXXFLAGS:= $(shell dpkg-buildflags --get CXXFLAGS) -std=gnu++14

# Fixes for 32-bit archss
ARCH_32BIT:=   i386 armel armhf mipsel hppa hurd-i386 m68k powerpc sh4 x32
ifneq ($(filter $(ARCH_32BIT),$(DEB_HOST_ARCH)),)
ENABLE_32BIT:= -DENABLE_32_BIT_HOST=On 
endif

# Needed for sbuild. metview creates temp directories during build
export HOME:=/tmp
export METVIEW_LOCALHOST:=127.0.0.1
export METVIEW_DEBUG:=1

# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

# Code should import these from eccodes-import but doesn't
export ECCODES_SAMPLES_PATH=/usr/share/eccodes/samples
export ECCODES_DEFINITION_PATH=/usr/share/eccodes/definitions
export ECCODES_IFS_SAMPLES_PATH=/usr/share/eccodes/ifs_samples

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_CPU)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
MV_DIR:=/usr/lib/$(DEB_HOST_MULTIARCH)/metview
export METVIEW_DIR_DEV:=$(CURDIR)/debian/build
export METVIEW_BIN:=$(METVIEW_DIR_DEV)/bin


# Hack until complter  uses this directory
FC:=$(shell basename $(shell readlink -f /usr/bin/f95))
FMODDIR:=$(LIBDIR)/fortran/$(FC)
FCFLAGS:=$(shell dpkg-buildflags --get FCFLAGS) -I $(FMODDIR)

LC_ALL=C
TZ=UTC+0
export LC_ALL TZ

FPIC:= ''
ifeq ($(TARGET_ARCH), i386)
	FPIC:= -fPIC
endif

# magic debhelper rule
%:
	dh $@ --buildsystem=ecbuild --builddirectory=$(METVIEW_DIR_DEV) 

#override_dh_auto_clean:
#	dh_auto_clean
#	rm -f metview/src/images/metview.png

# magics++ upstream ships with a copy of terralib, which is not used in Debian. 
# Instead we use # a shared terralib library, and so need to include terralib.
# Also -fPIC, for some reason.

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_EXPOSE_SUBPACKAGES=On \
		-DODB_PATH=/usr \
		-DENABLE_MIR_TOOLS=On \
		-DENABLE_PPROC_MIR=On \
		-DENABLE_URL_DOWNLOAD=On \
		-DENABLE_MPI=On \
		-DENABLE_PNG=On \
		-DENABLE_MIR_DOWNLOAD_MASKS=Off \
		-DENABLE_SCM_RTTOV=On \
		-DENABLE_EXPERIMENTAL=Off \
		-DENABLE_CODE_WEBHELP=Off \
		-DENABLE_CONTRIB=On \
		-DCMAKE_CXX_STANDARD=14 \
		-DCMAKE_CXX_STANDARD_REQUIRED=On \
		-DMETVIEW_SITE=debian  \
		-DMETVIEW_EXTRA_LIBRARIES='terralib -lemosR64 -leccodes -leckit -leckit_option' \
		-DMETVIEW_EXTRA_INCLUDE_DIRS=/usr/include/terralib/kernel \
		-DMAGICS_HAVE_METVIEW=True \
		-DMAGICS_HAVE_NETCDF=True \
		-DMAGICS_PATH=/usr \
		-DBUILD_SHARED_LIBS=On \
		-DSKIP_INSTALL_RPATHS=On \
		-DENABLE_RPATHS=Off \
		-DENABLE_RELATIVE_RPATHS=Off \
		-DENABLE_ODB=On \
		-Dodb_api_DIR=${LIBDIR}/cmake/odb_api \
		-DFLEXTRA_PATH=/usr/bin/flextra \
		-DDISABLE_OS_CHECK=On \
		-DCMAKE_Fortran_FLAGS=$(FCFLAGS) \
		-DFPIC=${FPIC} \
		-DCMAKE_Fortran_FLAGS='$(FCFLAGS)'  \
		$(ENABLE_32BIT)

	( cd ${METVIEW_DIR_DEV}/share ; tar axpf $(CURDIR)/../metview_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
	# These get generated ok on a machine with network connection, but fail on sbuilds, etc.
	# so copy pre-generated versions stored in etc
	mkdir -p debian/build/share/metview/etc/
	cp debian/etc/* debian/build/share/metview/etc/
	# cd debian/build/share/metview/etc && $(MAKE) ObjectListAllTarget
	cp metview/src/images/metview_logo.png metview/src/images/metview.png

override_dh_auto_test:
	echo IGNORING TESTS FOR THE MOMENT
	# ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  )

override_dh_fixperms-arch:
	dh_fixperms
	rm -f debian/metview/usr/lib/*/metvidew/metview_post_install_tests.sh
	# chmod 755 debian/metview/$(MV_DIR)/mv_compress
	mv debian/metview/$(MV_DIR)/metview_bin/* debian/metview/$(MV_DIR)
	rmdir debian/metview/$(MV_DIR)/metview_bin
	chmod 644 debian/metview/$(MV_DIR)/metview_*.common
	chmod 644 debian/metview/$(MV_DIR)/metview_stat
	chmod 644 debian/metview/$(MV_DIR)/metview_patches
	chmod 644 debian/metview/usr/share/images/metview/*
	file debian/metview/$(MV_DIR)/* | grep ELF | cut -f1 -d: | xargs chrpath -d
	chrpath -d debian/libmetview0d/usr/lib/*/lib*so.*

override_dh_fixperms-indep:
	dh_fixperms
	rm -rf debian/metview-data/usr/share/applications
	find debian/metview-data/usr/share/metview -type f -exec chmod 644 {} \;
	find debian/metview-data/usr/share/metview -type d -exec chmod 755 {} \;
